<script lang="ts">
	import { doc, setDoc } from 'firebase/firestore';
	import Button from '../../../../../components/Button.svelte';
	import Input from '../../../../../components/Input.svelte';
	import type { Category } from '../type';
	import { db } from '$lib/firebase/firebase';
	import { createEventDispatcher } from 'svelte';

	export let categories: Category[];

	function hasDuplicateOrders() {
		const orderValues = categories.map((obj) => parseInt(obj.order));
		const uniqueOrders = new Set(orderValues);
		return orderValues.length !== uniqueOrders.size;
	}

	let error = '';

	const editOrder = () => {
		error = '';
		categories = categories.map((obj) => {
			return {
				...obj,
				order: parseInt(obj.order)
			};
		});

		if (hasDuplicateOrders()) {
			error = 'Il y a des doublons dans les ordres';
		} else {
			categories.forEach((category) => {
				const docRef = doc(db, 'categories', category.id);
				setDoc(docRef, category, { merge: true });
				window.location.reload();
			});
		}
	};

	const dispatch = createEventDispatcher();
</script>

{#each categories as category}
	<div class="flex flex-col gap-2 p-4">
		<div class="flex gap-2 items-center">
			<div class="w-12">
				<Input label="" type="number" bind:value={category.order} />
			</div>
			<span class="text-lg font-semibold">
				{category.name}
			</span>
		</div>
	</div>
{/each}
<Button on:click={editOrder}>Changer l'ordre</Button>
{#if error}
	<p class="text-red-500">{error}</p>
{/if}
